# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: proj.pleaf.m4,v 1.4 2022/09/25 17:11:04 babolo Exp $
#
# 

eval
#perform 0002
CREATE TEMP TABLE p
     ( SQAT(sess) int
     , SQAT(ordr) int
     , SQAT(proj) int
     , SQAT(page) int
     , SQAT(pnam) text
     , SQAT(name) text
     ) STRICT
;
#perform 0002
INSERT INTO p(SQAT(ordr), SQAT(proj), SQAT(pnam), SQAT(name))
 SELECT SQNM(proj).SQAT(ordr) AS SQAT(ordr)
      , SQNM(proj).SQAT(proj) AS SQAT(proj)
      , SQNM(proj).SQAT(pnam) AS SQAT(pnam)
      , SQNM(proj).SQAT(name) AS SQAT(name)
  FROM SQNM(proj), SQNM(x) LEFT JOIN SQNM(lede) ON(SQNM(lede).SQAT(lede) == SQNM(x).SQAT(m))
  WHERE SQNM(proj).SQAT(vizi)
    AND CASE WHEN SQNM(x).SQAT(s) == 'r'
             THEN SQNM(proj).SQAT(proj) <> 0
             WHEN SQNM(x).SQAT(s) == 'm'
             THEN EXISTS(SELECT 1
                          FROM SQNM(ledeproj)
                          WHERE (SQNM(ledeproj).SQAT(lede) == SQNM(x).SQAT(m))
                            AND (SQNM(ledeproj).SQAT(proj) == SQNM(proj).SQAT(proj))
                        )
              AND SQNM(lede).SQAT(vizi)
             ELSE 1
        END
;
#select  _00_
SELECT CINM(x).CIAT(sess), CINM(pnode).CIAT(p), CINM(pnode).CIAT(m)
 FROM CINM(x), CINM(pnode)
 WHERE CINM(pnode).CIAT(v) == 'root'
;
#perform 00_2
UPDATE p SET SQAT(sess) = ?, SQAT(page) = ? WHERE SQAT(pnam) == ?;
#select  _002
SELECT SQAT(sess) AS sess, SQAT(page) AS page, SQAT(proj) AS proj, SQAT(name) AS name
 FROM p
ORDER BY SQAT(ordr)
;
#display 00_00p
#close   _0_00p
